/*
  All work in this is property of Jim Adams.
  I assume no responsibility of damages resulting in its use.
  You may freely distribute this as you feel.
  Make sure to give credit to me if you do.

                    Jim Adams  1996

  Converting this example to work with DirectX, really a straight 
  port. I didn't really take advantage of the additional DirectX stuff
  such as overlays. Compiled using Visual C++ 5.0 and DirectX 3.0a. Just
  wanted a working engine to figure out the iso engine plus test things
  with DirectX. Most of the source is Jim's. Added more comments for my clarity.
  rest if from the directX examples.

  Really bad animation techniques, 1 primary buffer and 1 back buffer which is flipped
  every so often...Right now I don't know any better way of doing it simply.

					Terence Tan 1997

  Fixed the clipping y problem, plus alot of bitmap problems related to the differences
  between the way jim does stuff..The y clipping problem was cause by not drawing enough
  y tiles, which must be done because the tiles are stacked(if this makes sense).

					Terence Tan 1997
*/

#define NAME "Example"
#define TITLE "Isometric engine example"

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include "ddutil.h"
#include "main.h"

#define TIMER_ID        1
#define TIMER_RATE      100

char *gfx_tile[40];

char *szBitmap = "tile";
/*
  Map structure, tile size is 32x15
  num = number of tiles at this coordinate,allowing stacking of tiles.
  tile = type of tile(0=grass,1=path..see back.bmp)
  height = how tall the tile reaches
  layer = used to make sure that the sprite doesn't block.Should use
          DirectX overlays to take care of this.
 */

typedef struct {
  char num;
  char tile[10];
  char height[10];
  char layer[10];
} MAP_INFO;
MAP_INFO map[32][32];

signed short int sprite_x,sprite_y,sprite_layer,sprite_frame;


/*
  Direct Draw Stuff
 */

LPDIRECTDRAW            lpDD;           // DirectDraw object
LPDIRECTDRAWSURFACE     lpDDSPrimary;   // DirectDraw primary surface
LPDIRECTDRAWSURFACE     lpDDSBack;       // background flip object
LPDIRECTDRAWSURFACE		lpDDSTiles;		// offscreen surface storing my tiles
LPDIRECTDRAWPALETTE     lpDDPal;        // DirectDraw palette
BOOL                    bActive;        // is application active?

/*
 * doInit - do work required for every instance of the application:
 *                create the window, initialize data
 */
static BOOL doInit( HINSTANCE hInstance, int nCmdShow )
{
    WNDCLASS            wc;
    DDSURFACEDESC       ddsd;
    HRESULT             ddrval;
	DDSCAPS             ddscaps;
    HWND				hwnd;

    /*
     * set up and register window class
     */
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon( hInstance, IDI_APPLICATION );
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = NULL;
    wc.lpszMenuName = NAME;
    wc.lpszClassName = NAME;
    RegisterClass( &wc );

    /*
     * create a window
     */
      hwnd = CreateWindowEx(
        WS_EX_TOPMOST,
        NAME,
        TITLE,
        WS_POPUP,
        0, 0,
        GetSystemMetrics( SM_CXSCREEN ),
        GetSystemMetrics( SM_CYSCREEN ),
        NULL,
        NULL,
        hInstance,
        NULL );

    if( !hwnd )
    {
        return FALSE;
    }

    ShowWindow( hwnd, nCmdShow );
    UpdateWindow( hwnd );

    /*
     * create the main DirectDraw object
     */
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if ( ddrval != DD_OK )
    {
        return initFail(hwnd);
    }

	ddrval = lpDD->SetCooperativeLevel( hwnd,
                                DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
       
    if ( ddrval != DD_OK ) 
	{
		return initFail(hwnd);
	}

	// Set display mode to 640 x 480 x 256 cause 320 x 200 doesn't seem to be support by directx
	ddrval = lpDD->SetDisplayMode( 640,480, 16 );

	if ( ddrval != DD_OK )
	{
		return initFail(hwnd);
	}
    // Create the primary surface, with one back buffer for flipping
    ddsd.dwSize = sizeof( ddsd );
                ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
                ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                                      DDSCAPS_FLIP | 
                                      DDSCAPS_COMPLEX;
    ddsd.dwBackBufferCount = 1;
    ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );

    if( ddrval != DD_OK )
    {
        return initFail(hwnd);
    }

	// Create back buffer

	ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, 
                                              &lpDDSBack);
                    
	if ( ddrval != DD_OK )
	{
		return initFail(hwnd);
	}

    // load our palette
    lpDDPal = DDLoadPalette(lpDD, "BACK.BMP");

    // make sure to set the palette before loading bitmaps.
    if (lpDDPal) 
        lpDDSPrimary->SetPalette(lpDDPal);


	lpDDSTiles = DDLoadBitmap(lpDD, "BACK.BMP", 0,0);

	if (lpDDSTiles == NULL) 
	{
		return initFail(hwnd);
	}

	
	DDSetColorKey(lpDDSTiles,RGB(0,0,0));

	// Create a timer to flip the pages
    if( !SetTimer( hwnd, TIMER_ID, TIMER_RATE, NULL ) )
    {
        return initFail(hwnd);
    }


	// setup_map 
	setup_map();

	// draw intial map on both back buffer and main one
	draw_map(lpDDSPrimary, 0,0);
	draw_map(lpDDSBack, 0,0);

	return TRUE;
} /* doInit */

/*
 * load data into map structure
 */

void setup_map() 
{
	signed short int i,j;
  char transform_map[32][32] = {
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,6,6,6,5,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,
    0,0,0,0,0,0,0,6,6,6,5,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,0,0,0,
    0,0,0,0,0,0,0,6,6,6,5,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,0,0,0,0,0,
    0,0,0,0,0,0,0,4,4,7,3,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,6,6,6,6,5,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,6,6,6,6,5,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,6,6,6,6,5,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,6,6,6,6,6,5,0,1,0,0,0,0,0,0,0,6,6,6,5,0,0,0,0,0,0,0,0,0,0,0,0,
    0,6,6,6,6,6,8,1,1,0,0,0,0,0,0,0,6,6,6,5,0,0,0,0,0,0,0,0,0,0,0,0,
    0,4,4,4,4,4,3,0,0,0,0,0,0,0,0,0,4,4,4,3,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,2,0,0,0,0,0,0,0,0,
    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,0,0,0 };

  // transform the map into map structure
  for(i=0;i<32;i++) {
    for(j=0;j<32;j++) {
      switch(transform_map[i][j]) {
        case 0:  map[i][j].num       = 1;
                 map[i][j].tile[0]   = 0;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 0;
                 break;
        case 1:  map[i][j].num       = 1;
                 map[i][j].tile[0]   = 1;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 0;
                 break;
        case 2:  map[i][j].num       = 1;
                 map[i][j].tile[0]   = 2;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 0;
                 break;
        case 3:  map[i][j].num       = 3;
                 map[i][j].tile[0]   = 3;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 1;
                 map[i][j].tile[1]   = 4;
                 map[i][j].height[1] = 0;
                 map[i][j].layer[1]  = 1;
                 map[i][j].tile[2]   = 5;
                 map[i][j].height[2] = 8;
                 map[i][j].layer[2]  = 2;
                 break;
        case 4:  map[i][j].num       = 2;
                 map[i][j].tile[0]   = 3;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 1;
                 map[i][j].tile[1]   = 5;
                 map[i][j].height[1] = 8;
                 map[i][j].layer[1]  = 2;
                 break;
        case 5:  map[i][j].num       = 2;
                 map[i][j].tile[0]   = 4;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 1;
                 map[i][j].tile[1]   = 5;
                 map[i][j].height[1] = 8;
                 map[i][j].layer[1]  = 2;
                 break;
        case 6:  map[i][j].num       = 1;
                 map[i][j].tile[0]   = 5;
                 map[i][j].height[0] = 8;
                 map[i][j].layer[0]  = 2;
                 break;
        case 7:  map[i][j].num       = 3;
                 map[i][j].tile[0]   = 3;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 1;
                 map[i][j].tile[1]   = 10;
                 map[i][j].height[1] = 0;
                 map[i][j].layer[1]  = 1;
                 map[i][j].tile[2]   = 5;
                 map[i][j].height[2] = 8;
                 map[i][j].layer[2]  = 2;
                 break;
        case 8:  map[i][j].num       = 3;
                 map[i][j].tile[0]   = 4;
                 map[i][j].height[0] = 0;
                 map[i][j].layer[0]  = 1;
                 map[i][j].tile[1]   = 11;
                 map[i][j].height[1] = 0;
                 map[i][j].layer[1]  = 1;
                 map[i][j].tile[2]   = 5;
                 map[i][j].height[2] = 8;
                 map[i][j].layer[2]  = 2;
                 break;
      }
    }
  }

}

/*
 * Draw map, takes direct draw surface,  and fine coordinates as input
 */

void draw_map(LPDIRECTDRAWSURFACE lpDDSScreen, signed short int x,signed short int y)
{
  signed short int i,j,k;
  signed short int current_layer,highest_layer,next_layer,last_layer;
  signed short int mapx,mapy,mx,my,tx,ty,xo,yo,xa,ya,screenx,screeny;
  signed short int length;
  char tile_to_draw,height_to_draw;

  signed short int sprite_mx,sprite_my,xx,yy;

  current_layer = 0;
  highest_layer = 0;
  last_layer    = 0;

  sprite_mx = sprite_x / 16;
  sprite_my = sprite_y / 16;

  /*
   * Convert fine coordinates to real coordiantes
   */
  mapx = x / 16;
  xo   = x & 15;
  mapy = y / 16;
  yo   = y & 15;
  xa   = xo - yo;
  ya   = (xo>>1) + (yo>>1);

  while(1) {
	  /*
	   * This look takes care of layers
       */

    next_layer = 255;
    mx = mapx;
    my = mapy;
    screeny = 8 - ya;

   
    for(i=0;i<70;i++) {
   /*
    * This loop takes care of the vertical screen draw
	*/
	  tx = mx;
      ty = my;

      screenx = 16 - xa;

      length = 24;
      if(i&1) {
        length++;
        screenx-=16;
      }

      for(j=0;j<length;j++) {
/*
 * This loop takes care of the horizontal screen draw which is done first
 */

        for(k=0;k<map[ty][tx].num;k++) {
/*
 * This loop takes care of all the tiles in this tile coordinate
 */
			if(map[ty][tx].layer[k] == current_layer) {
            tile_to_draw = map[ty][tx].tile[k];
            height_to_draw = map[ty][tx].height[k];
			blockDraw(lpDDSScreen, screenx, screeny-height_to_draw, 32, 50,tile_to_draw);
          }

          if(tx == sprite_mx && ty == sprite_my && current_layer==sprite_layer) {
            xo = sprite_x & 15;
            yo = sprite_y & 15;
            xx   = xo - yo;
            yy   = (xo>>1) + (yo>>1);
			blockDraw(lpDDSScreen, screenx-32+xx, screeny-16+yy, 32,50,sprite_frame);
          }

          if(map[ty][tx].layer[k] > highest_layer)
             highest_layer = map[ty][tx].layer[k];

          if(map[ty][tx].layer[k] < next_layer && map[ty][tx].layer[k] > last_layer)
            next_layer = map[ty][tx].layer[k];
        }

        screenx+=32;

        // map update and wrap around
        if((tx+=1) > 31)
          tx = 0;
        if((ty-=1) < 0)
          ty = 31;
      }

      screeny+=8;

      if(i & 1) {
        if((mx+=1) > 31)
          mx = 0;
      } else {
        if((my+=1) > 31)
          my = 0;
      }
    }

    last_layer = current_layer;
    // smudge to fit in sprite layer
    if(current_layer == 0)
      current_layer = 1;
    else current_layer = next_layer;

    if(current_layer > highest_layer)
      break;
  }
}

/*
 * This function will wait until the blit has been completed..a better way of
 * doing this to fork off a thread which will wait for each to finish..A better way
 * is fork a thread of for each map draw, set a flag letting a flip occur only when
 * its done instead of blocking...then again...games usually eat up all computer
 * resources so who cares......Draws exactly 1 tile
 */

int blockDraw(LPDIRECTDRAWSURFACE lpDDSScreen, signed short x, signed short y, unsigned short w, unsigned short h, int tile)
{

	unsigned short xoff, yoff;
	unsigned short xlen, ylen;
	unsigned short height;
	HRESULT ddrval;

	
	switch (tile) 
	{
	case 0:
		height=15;
		break;
	case 1:
		height=15;
		break;
	case 2:
		height=15;
		break;
	case 3:
		height=50;
		break;
	case 4:
		height=50;
		break;
	case 5:
		height=15;
		break;
	case 6:
		height=27;
		break;
	case 7:
		height=27;
		break;
	case 8:
		height=25;
		break;
	case 9:
		height=15;
		break;
	case 10:
	case 11:
		height=50;
		break;
	default:
		height=50;
		break;

	}

	x-=32;
	y-=50;

	xlen = w;
	ylen = height;
	xoff = 0;
	yoff = 50-height;

	if (x < 0) 
	{
		xlen+=x;
		xoff=-x;
		x=0;
	}

	if (x+w > 639) 
	{
		xlen=640-x;
	}

	if (y < 0)
	{
		ylen=height+y;
		yoff+=(y*-1);
		y=0;
	}

	if (y+height > 479)
	{
		ylen=480-y;
		if (y>480) 
		{
			return 1;
		}
	}

	if (xlen< 0 || ylen < 0) 
	{
		return 1;
	}

	
	// Blit tile from tile surface

	while(1)
	{
		ddrval=BlitTile(lpDDSScreen,tile,x,y,xlen,ylen,xoff,yoff);

		if (ddrval == DD_OK)
		{
			break;
		}
	    if( ddrval != DDERR_WASSTILLDRAWING )
        {
            break;
        }
    }
	return 0;
}

/*
 * Do the tile blit               
 * make sure we get the tile from bottom up(^)..because the tile starts from doesnt go down
 */

HRESULT BlitTile(LPDIRECTDRAWSURFACE lpDDSScreen, int tile, unsigned short x, unsigned short y, unsigned short w, unsigned short h, unsigned short xoff, unsigned short yoff) 
{
	unsigned short xoffset,yoffset;
	RECT rcRect;

	if (tile < 10) 
	{
		xoffset=tile*32;
		yoffset=0;
	}
    else
	if (tile < 20) 
	{
		xoffset=(tile-10) * 32;
		yoffset=50;
	}
	else
	if (tile < 30) 
	{
		xoffset=(tile-20) * 32;
		yoffset=100;
	}
	else
	if (tile < 40)
	{
		xoffset=(tile=30) * 32;
		yoffset=150;
	}


	rcRect.left=xoffset+xoff;
	rcRect.top=yoffset+yoff;
	rcRect.right=xoffset+xoff+w;
	rcRect.bottom=yoffset+yoff+h;

	return lpDDSScreen->BltFast(x,y,lpDDSTiles,&rcRect,DDBLTFAST_SRCCOLORKEY);
}

/*
 * finiObjects
 *
 * finished with all objects we use; release them
 */
static void finiObjects( void )
{
    if( lpDD != NULL )
    {
        if( lpDDSPrimary != NULL )
        {
            lpDDSPrimary->Release();
            lpDDSPrimary = NULL;
        }

		if ( lpDDSTiles != NULL )
		{
			lpDDSTiles->Release();
			lpDDSTiles = NULL;
		}

        if( lpDDPal != NULL )
        {
            lpDDPal->Release();
            lpDDPal = NULL;
        }
        lpDD->Release();
        lpDD = NULL;
    }
} /* finiObjects */


/*
   Main windows loop, check for key press and update screen here
 */

long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
                            WPARAM wParam, LPARAM lParam )
{
 	HRESULT ddrval;
	int phase=0; // which screen are we using, 0 = primary, 1=other 

	static signed short int viewx, viewy, scroll_speed;

    switch( message )
    {
	case WM_CREATE:
		viewx=0;
		viewy=0;
		scroll_speed=2;

		sprite_x=0;
		sprite_y=0;
		sprite_layer=1;
		sprite_frame=12;
		
		break;
    case WM_ACTIVATEAPP:
        bActive = wParam;
        break;

	case WM_TIMER:
		if (bActive)
		{
 
/* Animate sprite here*/
 
		sprite_x += ((rand()%4 -2) *2);
		sprite_y += ((rand()%4 -2) *2);
		if (sprite_x<0)
			sprite_x+=32*16;
		if (sprite_x > 32*16)
			sprite_x-=32*16;
		if (sprite_y<0)
			sprite_y+=32*16;
		if (sprite_y>32*16)
			sprite_y-=32*16;
		if (sprite_frame == 12)
			sprite_frame = 13;
		else
			sprite_frame = 12;

		/*
		 * check if the coordinates have crossed the normal boundaries
		 * of fine coordinates
		 */
			if (viewx < 0 ) 
				viewx +=32*16;
			if (viewx >=32*16)
				viewx -=32*16;
			if (viewy < 0)
				viewy +=32*16;
			if (viewy >= 32*16)
				viewy -=32*16;
				draw_map(lpDDSBack,viewx,viewy);
		
		// Flip surfaces
            while( 1 )
            {
                ddrval = lpDDSPrimary->Flip( NULL, 0 );
                if( ddrval == DD_OK )
                {
					if (phase) 
					{
						phase=0;
					} else {
						phase=1;
					}
			       break;
                }
                if( ddrval != DDERR_WASSTILLDRAWING )
                {
                    break;
                }
            }
        } 
        break;
    case WM_KEYDOWN:

        switch( wParam )
        {
		case VK_LEFT:
			viewx-=scroll_speed;
			viewy+=scroll_speed;
			break;
		case VK_RIGHT:
			viewx+=scroll_speed;
			viewy-=scroll_speed;
			break;
		case VK_UP:
			viewx-=scroll_speed;
			viewy-=scroll_speed;
			break;
		case VK_DOWN:
			viewx+=scroll_speed;
			viewy+=scroll_speed;
			break;
		case VK_HOME:
			viewx-=scroll_speed;
			break;
		case VK_END:
			viewy+=scroll_speed;
			break;
		case VK_PRIOR:
			viewy-=scroll_speed;
			break;
		case VK_NEXT:
			viewx+=scroll_speed;
			break;
		case 0x30:
		case VK_NUMPAD0:
			scroll_speed=2;
			break;
		case 0x31:
		case VK_NUMPAD1:
			scroll_speed=4;
			break;
		case 0x32:
		case VK_NUMPAD2:
			scroll_speed=6;
			break;
		case 0x33:
		case VK_NUMPAD3:
			scroll_speed=8;
			break;
		case 0x34:
		case VK_NUMPAD4:
			scroll_speed=10;
			break;
		case 0x35:
		case VK_NUMPAD5:
			scroll_speed=12;
			break;
		case 0x36:
		case VK_NUMPAD6:
			scroll_speed=14;
			break;
		case 0x37:
		case VK_NUMPAD7:
			scroll_speed=16;
			break;
		case 0x38:
		case VK_NUMPAD8:
			scroll_speed=18;
			break;
		case 0x39:
		case VK_NUMPAD9:
			scroll_speed=20;
			break;
        case VK_ESCAPE:
        case VK_F12:
            PostMessage(hWnd, WM_CLOSE, 0, 0);
            break;
        }
        break;

    case WM_DESTROY:
        finiObjects();
        PostQuitMessage( 0 );
        break;

    }

    return DefWindowProc(hWnd, message, wParam, lParam);

} /* WindowProc */


/*
 * This function is called if the initialization function fails
 */
BOOL initFail( HWND hwnd )
{
    finiObjects();
    MessageBox( hwnd, "DirectDraw Init FAILED", TITLE, MB_OK );
    DestroyWindow( hwnd );
    return FALSE;

} /* initFail */


/*
 * WinMain - initialization, message loop
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{
    MSG         msg;

    if( !doInit( hInstance, nCmdShow ) )
    {
        return FALSE;
    }

	while (GetMessage(&msg, NULL, 0, 0))
    {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }

    return msg.wParam;

} /* WinMain */
